=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class AffiliateClick
    # Unique object identifier for this click
    attr_accessor :affiliate_click_oid

    # Unique object identifier for for the link that this click is associated with
    attr_accessor :affiliate_link_oid

    # Affiliate object ID associated with this click
    attr_accessor :affiliate_oid

    # Date/time that the click was made
    attr_accessor :click_dts

    # IP address that generated the click
    attr_accessor :ip_address

    # URL of the landing page the customer was sent to.
    attr_accessor :landing_page

    # Query string on the landing page URL the customer was sent to.
    attr_accessor :landing_page_query_string

    attr_accessor :link

    # URL that referred the click (Browser Header Referer)
    attr_accessor :referrer

    # Query string that was on the referrer URL.
    attr_accessor :referrer_query_string

    # Sub ID value passed on the click
    attr_accessor :sub_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'affiliate_click_oid' => :'affiliate_click_oid',
        :'affiliate_link_oid' => :'affiliate_link_oid',
        :'affiliate_oid' => :'affiliate_oid',
        :'click_dts' => :'click_dts',
        :'ip_address' => :'ip_address',
        :'landing_page' => :'landing_page',
        :'landing_page_query_string' => :'landing_page_query_string',
        :'link' => :'link',
        :'referrer' => :'referrer',
        :'referrer_query_string' => :'referrer_query_string',
        :'sub_id' => :'sub_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'affiliate_click_oid' => :'Integer',
        :'affiliate_link_oid' => :'Integer',
        :'affiliate_oid' => :'Integer',
        :'click_dts' => :'String',
        :'ip_address' => :'String',
        :'landing_page' => :'String',
        :'landing_page_query_string' => :'String',
        :'link' => :'AffiliateLink',
        :'referrer' => :'String',
        :'referrer_query_string' => :'String',
        :'sub_id' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'affiliate_click_oid')
        self.affiliate_click_oid = attributes[:'affiliate_click_oid']
      end

      if attributes.has_key?(:'affiliate_link_oid')
        self.affiliate_link_oid = attributes[:'affiliate_link_oid']
      end

      if attributes.has_key?(:'affiliate_oid')
        self.affiliate_oid = attributes[:'affiliate_oid']
      end

      if attributes.has_key?(:'click_dts')
        self.click_dts = attributes[:'click_dts']
      end

      if attributes.has_key?(:'ip_address')
        self.ip_address = attributes[:'ip_address']
      end

      if attributes.has_key?(:'landing_page')
        self.landing_page = attributes[:'landing_page']
      end

      if attributes.has_key?(:'landing_page_query_string')
        self.landing_page_query_string = attributes[:'landing_page_query_string']
      end

      if attributes.has_key?(:'link')
        self.link = attributes[:'link']
      end

      if attributes.has_key?(:'referrer')
        self.referrer = attributes[:'referrer']
      end

      if attributes.has_key?(:'referrer_query_string')
        self.referrer_query_string = attributes[:'referrer_query_string']
      end

      if attributes.has_key?(:'sub_id')
        self.sub_id = attributes[:'sub_id']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          affiliate_click_oid == o.affiliate_click_oid &&
          affiliate_link_oid == o.affiliate_link_oid &&
          affiliate_oid == o.affiliate_oid &&
          click_dts == o.click_dts &&
          ip_address == o.ip_address &&
          landing_page == o.landing_page &&
          landing_page_query_string == o.landing_page_query_string &&
          link == o.link &&
          referrer == o.referrer &&
          referrer_query_string == o.referrer_query_string &&
          sub_id == o.sub_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [affiliate_click_oid, affiliate_link_oid, affiliate_oid, click_dts, ip_address, landing_page, landing_page_query_string, link, referrer, referrer_query_string, sub_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
