=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class CartSettingsShippingEstimate
    # True if this method allows the customer to use their own shipper account number
    attr_accessor :allow_3rd_party_billing

    # Comment to display to the customer about this method
    attr_accessor :comment

    attr_accessor :cost

    attr_accessor :cost_before_discount

    # True if this is the default method
    attr_accessor :default_method

    attr_accessor :discount

    # True if this method is discounted because of a coupon
    attr_accessor :discounted

    # The name to display to the customer
    attr_accessor :display_name

    # Date of the estimated delivery (or range)
    attr_accessor :estimated_delivery

    # True if a lift gate option for this method should be offered to the customer
    attr_accessor :lift_gate_option

    # Shipping method name
    attr_accessor :name

    attr_accessor :tax

    attr_accessor :total_tax

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'allow_3rd_party_billing' => :'allow_3rd_party_billing',
        :'comment' => :'comment',
        :'cost' => :'cost',
        :'cost_before_discount' => :'cost_before_discount',
        :'default_method' => :'default_method',
        :'discount' => :'discount',
        :'discounted' => :'discounted',
        :'display_name' => :'display_name',
        :'estimated_delivery' => :'estimated_delivery',
        :'lift_gate_option' => :'lift_gate_option',
        :'name' => :'name',
        :'tax' => :'tax',
        :'total_tax' => :'total_tax'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'allow_3rd_party_billing' => :'BOOLEAN',
        :'comment' => :'String',
        :'cost' => :'Currency',
        :'cost_before_discount' => :'Currency',
        :'default_method' => :'BOOLEAN',
        :'discount' => :'Currency',
        :'discounted' => :'BOOLEAN',
        :'display_name' => :'String',
        :'estimated_delivery' => :'String',
        :'lift_gate_option' => :'BOOLEAN',
        :'name' => :'String',
        :'tax' => :'Currency',
        :'total_tax' => :'Currency'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'allow_3rd_party_billing')
        self.allow_3rd_party_billing = attributes[:'allow_3rd_party_billing']
      end

      if attributes.has_key?(:'comment')
        self.comment = attributes[:'comment']
      end

      if attributes.has_key?(:'cost')
        self.cost = attributes[:'cost']
      end

      if attributes.has_key?(:'cost_before_discount')
        self.cost_before_discount = attributes[:'cost_before_discount']
      end

      if attributes.has_key?(:'default_method')
        self.default_method = attributes[:'default_method']
      end

      if attributes.has_key?(:'discount')
        self.discount = attributes[:'discount']
      end

      if attributes.has_key?(:'discounted')
        self.discounted = attributes[:'discounted']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'estimated_delivery')
        self.estimated_delivery = attributes[:'estimated_delivery']
      end

      if attributes.has_key?(:'lift_gate_option')
        self.lift_gate_option = attributes[:'lift_gate_option']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'tax')
        self.tax = attributes[:'tax']
      end

      if attributes.has_key?(:'total_tax')
        self.total_tax = attributes[:'total_tax']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          allow_3rd_party_billing == o.allow_3rd_party_billing &&
          comment == o.comment &&
          cost == o.cost &&
          cost_before_discount == o.cost_before_discount &&
          default_method == o.default_method &&
          discount == o.discount &&
          discounted == o.discounted &&
          display_name == o.display_name &&
          estimated_delivery == o.estimated_delivery &&
          lift_gate_option == o.lift_gate_option &&
          name == o.name &&
          tax == o.tax &&
          total_tax == o.total_tax
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [allow_3rd_party_billing, comment, cost, cost_before_discount, default_method, discount, discounted, display_name, estimated_delivery, lift_gate_option, name, tax, total_tax].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
