=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class CustomerCard
    # Card expiration month (1-12)
    attr_accessor :card_expiration_month

    # Card expiration year (four digit year)
    attr_accessor :card_expiration_year

    # Card number (masked to the last 4)
    attr_accessor :card_number

    # Hosted field token for the card number
    attr_accessor :card_number_token

    # Card type
    attr_accessor :card_type

    # ID of the stored credit card to use
    attr_accessor :customer_profile_credit_card_id

    # Customer profile object identifier
    attr_accessor :customer_profile_oid

    # Last used date
    attr_accessor :last_used_dts

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'card_expiration_month' => :'card_expiration_month',
        :'card_expiration_year' => :'card_expiration_year',
        :'card_number' => :'card_number',
        :'card_number_token' => :'card_number_token',
        :'card_type' => :'card_type',
        :'customer_profile_credit_card_id' => :'customer_profile_credit_card_id',
        :'customer_profile_oid' => :'customer_profile_oid',
        :'last_used_dts' => :'last_used_dts'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'card_expiration_month' => :'Integer',
        :'card_expiration_year' => :'Integer',
        :'card_number' => :'String',
        :'card_number_token' => :'String',
        :'card_type' => :'String',
        :'customer_profile_credit_card_id' => :'Integer',
        :'customer_profile_oid' => :'Integer',
        :'last_used_dts' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'card_expiration_month')
        self.card_expiration_month = attributes[:'card_expiration_month']
      end

      if attributes.has_key?(:'card_expiration_year')
        self.card_expiration_year = attributes[:'card_expiration_year']
      end

      if attributes.has_key?(:'card_number')
        self.card_number = attributes[:'card_number']
      end

      if attributes.has_key?(:'card_number_token')
        self.card_number_token = attributes[:'card_number_token']
      end

      if attributes.has_key?(:'card_type')
        self.card_type = attributes[:'card_type']
      end

      if attributes.has_key?(:'customer_profile_credit_card_id')
        self.customer_profile_credit_card_id = attributes[:'customer_profile_credit_card_id']
      end

      if attributes.has_key?(:'customer_profile_oid')
        self.customer_profile_oid = attributes[:'customer_profile_oid']
      end

      if attributes.has_key?(:'last_used_dts')
        self.last_used_dts = attributes[:'last_used_dts']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          card_expiration_month == o.card_expiration_month &&
          card_expiration_year == o.card_expiration_year &&
          card_number == o.card_number &&
          card_number_token == o.card_number_token &&
          card_type == o.card_type &&
          customer_profile_credit_card_id == o.customer_profile_credit_card_id &&
          customer_profile_oid == o.customer_profile_oid &&
          last_used_dts == o.last_used_dts
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [card_expiration_month, card_expiration_year, card_number, card_number_token, card_type, customer_profile_credit_card_id, customer_profile_oid, last_used_dts].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
