=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class EmailDomain
    attr_accessor :comment

    attr_accessor :dkim

    attr_accessor :dkim_status

    attr_accessor :domain

    attr_accessor :esp_domain_uuid

    attr_accessor :identity_status

    attr_accessor :merchant_id

    attr_accessor :provider

    attr_accessor :start_dkim_dts

    attr_accessor :start_identity_dts

    attr_accessor :verification

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'comment' => :'comment',
        :'dkim' => :'dkim',
        :'dkim_status' => :'dkim_status',
        :'domain' => :'domain',
        :'esp_domain_uuid' => :'esp_domain_uuid',
        :'identity_status' => :'identity_status',
        :'merchant_id' => :'merchant_id',
        :'provider' => :'provider',
        :'start_dkim_dts' => :'start_dkim_dts',
        :'start_identity_dts' => :'start_identity_dts',
        :'verification' => :'verification'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'comment' => :'String',
        :'dkim' => :'Array<VerificationRecord>',
        :'dkim_status' => :'String',
        :'domain' => :'String',
        :'esp_domain_uuid' => :'String',
        :'identity_status' => :'String',
        :'merchant_id' => :'String',
        :'provider' => :'String',
        :'start_dkim_dts' => :'String',
        :'start_identity_dts' => :'String',
        :'verification' => :'VerificationRecord'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'comment')
        self.comment = attributes[:'comment']
      end

      if attributes.has_key?(:'dkim')
        if (value = attributes[:'dkim']).is_a?(Array)
          self.dkim = value
        end
      end

      if attributes.has_key?(:'dkim_status')
        self.dkim_status = attributes[:'dkim_status']
      end

      if attributes.has_key?(:'domain')
        self.domain = attributes[:'domain']
      end

      if attributes.has_key?(:'esp_domain_uuid')
        self.esp_domain_uuid = attributes[:'esp_domain_uuid']
      end

      if attributes.has_key?(:'identity_status')
        self.identity_status = attributes[:'identity_status']
      end

      if attributes.has_key?(:'merchant_id')
        self.merchant_id = attributes[:'merchant_id']
      end

      if attributes.has_key?(:'provider')
        self.provider = attributes[:'provider']
      end

      if attributes.has_key?(:'start_dkim_dts')
        self.start_dkim_dts = attributes[:'start_dkim_dts']
      end

      if attributes.has_key?(:'start_identity_dts')
        self.start_identity_dts = attributes[:'start_identity_dts']
      end

      if attributes.has_key?(:'verification')
        self.verification = attributes[:'verification']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          comment == o.comment &&
          dkim == o.dkim &&
          dkim_status == o.dkim_status &&
          domain == o.domain &&
          esp_domain_uuid == o.esp_domain_uuid &&
          identity_status == o.identity_status &&
          merchant_id == o.merchant_id &&
          provider == o.provider &&
          start_dkim_dts == o.start_dkim_dts &&
          start_identity_dts == o.start_identity_dts &&
          verification == o.verification
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [comment, dkim, dkim_status, domain, esp_domain_uuid, identity_status, merchant_id, provider, start_dkim_dts, start_identity_dts, verification].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
