=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class ItemContentAssignment
    # True if this group is the default assignment for this item
    attr_accessor :default_assignment

    # Page (group) object identifier
    attr_accessor :group_oid

    # Page (group) path
    attr_accessor :group_path

    # StoreFront host name
    attr_accessor :host

    # Sort order (optional)
    attr_accessor :sort_order

    # URL part if the item id is not used
    attr_accessor :url_part

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'default_assignment' => :'default_assignment',
        :'group_oid' => :'group_oid',
        :'group_path' => :'group_path',
        :'host' => :'host',
        :'sort_order' => :'sort_order',
        :'url_part' => :'url_part'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'default_assignment' => :'BOOLEAN',
        :'group_oid' => :'Integer',
        :'group_path' => :'String',
        :'host' => :'String',
        :'sort_order' => :'Integer',
        :'url_part' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'default_assignment')
        self.default_assignment = attributes[:'default_assignment']
      end

      if attributes.has_key?(:'group_oid')
        self.group_oid = attributes[:'group_oid']
      end

      if attributes.has_key?(:'group_path')
        self.group_path = attributes[:'group_path']
      end

      if attributes.has_key?(:'host')
        self.host = attributes[:'host']
      end

      if attributes.has_key?(:'sort_order')
        self.sort_order = attributes[:'sort_order']
      end

      if attributes.has_key?(:'url_part')
        self.url_part = attributes[:'url_part']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@url_part.nil? && @url_part.to_s.length > 150
        invalid_properties.push('invalid value for "url_part", the character length must be smaller than or equal to 150.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@url_part.nil? && @url_part.to_s.length > 150
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] url_part Value to be assigned
    def url_part=(url_part)
      if !url_part.nil? && url_part.to_s.length > 150
        fail ArgumentError, 'invalid value for "url_part", the character length must be smaller than or equal to 150.'
      end

      @url_part = url_part
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          default_assignment == o.default_assignment &&
          group_oid == o.group_oid &&
          group_path == o.group_path &&
          host == o.host &&
          sort_order == o.sort_order &&
          url_part == o.url_part
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [default_assignment, group_oid, group_path, host, sort_order, url_part].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
