=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class ItemThirdPartyEmailMarketing
    # Add tags
    attr_accessor :add_tags

    # Provider name
    attr_accessor :provider_name

    # Remove tags
    attr_accessor :remove_tags

    # Subscribe to lists
    attr_accessor :subscribe_lists

    # Unsubscribe from lists
    attr_accessor :unsubscribe_lists

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'add_tags' => :'add_tags',
        :'provider_name' => :'provider_name',
        :'remove_tags' => :'remove_tags',
        :'subscribe_lists' => :'subscribe_lists',
        :'unsubscribe_lists' => :'unsubscribe_lists'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'add_tags' => :'Array<String>',
        :'provider_name' => :'String',
        :'remove_tags' => :'Array<String>',
        :'subscribe_lists' => :'Array<String>',
        :'unsubscribe_lists' => :'Array<String>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'add_tags')
        if (value = attributes[:'add_tags']).is_a?(Array)
          self.add_tags = value
        end
      end

      if attributes.has_key?(:'provider_name')
        self.provider_name = attributes[:'provider_name']
      end

      if attributes.has_key?(:'remove_tags')
        if (value = attributes[:'remove_tags']).is_a?(Array)
          self.remove_tags = value
        end
      end

      if attributes.has_key?(:'subscribe_lists')
        if (value = attributes[:'subscribe_lists']).is_a?(Array)
          self.subscribe_lists = value
        end
      end

      if attributes.has_key?(:'unsubscribe_lists')
        if (value = attributes[:'unsubscribe_lists']).is_a?(Array)
          self.unsubscribe_lists = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      provider_name_validator = EnumAttributeValidator.new('String', ['ActiveCampaign', 'AWeber', 'Campaign Monitor', 'ConstantContact', 'Emma', 'GetResponse', 'iContact', 'Klaviyo', 'Lyris', 'LyrisHQ', 'MailChimp', 'SilverPop'])
      return false unless provider_name_validator.valid?(@provider_name)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] provider_name Object to be assigned
    def provider_name=(provider_name)
      validator = EnumAttributeValidator.new('String', ['ActiveCampaign', 'AWeber', 'Campaign Monitor', 'ConstantContact', 'Emma', 'GetResponse', 'iContact', 'Klaviyo', 'Lyris', 'LyrisHQ', 'MailChimp', 'SilverPop'])
      unless validator.valid?(provider_name)
        fail ArgumentError, 'invalid value for "provider_name", must be one of #{validator.allowable_values}.'
      end
      @provider_name = provider_name
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          add_tags == o.add_tags &&
          provider_name == o.provider_name &&
          remove_tags == o.remove_tags &&
          subscribe_lists == o.subscribe_lists &&
          unsubscribe_lists == o.unsubscribe_lists
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [add_tags, provider_name, remove_tags, subscribe_lists, unsubscribe_lists].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
