=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class LibraryItemPublishedMeta
    # The number of published versions a source item has, or zero if this item is not a source or is private
    attr_accessor :count_of_versions

    # The oid pointing to the most recent published version, or zero if this is not a published source item.
    attr_accessor :library_item_published_oid

    # The oid pointing to the review data if this is a source library item and currently under review
    attr_accessor :library_item_review_oid

    # True if this is a source item and is under review and was rejected.
    attr_accessor :rejected

    # The reason for rejection if this item is a source item, is under review, and was rejected.  For all other cases, this value will be null or missing.
    attr_accessor :rejected_reason

    # If this library item is a source item and it is published, this is the most recent release version number
    attr_accessor :release_version

    # If this library item is a source item and has a published item currently under review, this is that version number
    attr_accessor :review_version

    # True if this library item is a source item and is currently under review
    attr_accessor :under_review

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'count_of_versions' => :'count_of_versions',
        :'library_item_published_oid' => :'library_item_published_oid',
        :'library_item_review_oid' => :'library_item_review_oid',
        :'rejected' => :'rejected',
        :'rejected_reason' => :'rejected_reason',
        :'release_version' => :'release_version',
        :'review_version' => :'review_version',
        :'under_review' => :'under_review'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'count_of_versions' => :'Integer',
        :'library_item_published_oid' => :'Integer',
        :'library_item_review_oid' => :'Integer',
        :'rejected' => :'BOOLEAN',
        :'rejected_reason' => :'String',
        :'release_version' => :'Integer',
        :'review_version' => :'Integer',
        :'under_review' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'count_of_versions')
        self.count_of_versions = attributes[:'count_of_versions']
      end

      if attributes.has_key?(:'library_item_published_oid')
        self.library_item_published_oid = attributes[:'library_item_published_oid']
      end

      if attributes.has_key?(:'library_item_review_oid')
        self.library_item_review_oid = attributes[:'library_item_review_oid']
      end

      if attributes.has_key?(:'rejected')
        self.rejected = attributes[:'rejected']
      end

      if attributes.has_key?(:'rejected_reason')
        self.rejected_reason = attributes[:'rejected_reason']
      end

      if attributes.has_key?(:'release_version')
        self.release_version = attributes[:'release_version']
      end

      if attributes.has_key?(:'review_version')
        self.review_version = attributes[:'review_version']
      end

      if attributes.has_key?(:'under_review')
        self.under_review = attributes[:'under_review']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          count_of_versions == o.count_of_versions &&
          library_item_published_oid == o.library_item_published_oid &&
          library_item_review_oid == o.library_item_review_oid &&
          rejected == o.rejected &&
          rejected_reason == o.rejected_reason &&
          release_version == o.release_version &&
          review_version == o.review_version &&
          under_review == o.under_review
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [count_of_versions, library_item_published_oid, library_item_review_oid, rejected, rejected_reason, release_version, review_version, under_review].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
