=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class OrderCheckout
    # Comments from the customer.  Rarely used on the single page checkout.
    attr_accessor :comments

    # Custom field 1
    attr_accessor :custom_field1

    # Custom field 2
    attr_accessor :custom_field2

    # Custom field 3
    attr_accessor :custom_field3

    # Custom field 4
    attr_accessor :custom_field4

    # Custom field 5
    attr_accessor :custom_field5

    # Custom field 6
    attr_accessor :custom_field6

    # Custom field 7
    attr_accessor :custom_field7

    # IP address of the customer when placing the order
    attr_accessor :customer_ip_address

    # Screen branding theme code associated with the order (legacy checkout)
    attr_accessor :screen_branding_theme_code

    # StoreFront host name associated with the order
    attr_accessor :storefront_host_name

    # Upsell path code assigned during the checkout that the customer went through
    attr_accessor :upsell_path_code

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'comments' => :'comments',
        :'custom_field1' => :'custom_field1',
        :'custom_field2' => :'custom_field2',
        :'custom_field3' => :'custom_field3',
        :'custom_field4' => :'custom_field4',
        :'custom_field5' => :'custom_field5',
        :'custom_field6' => :'custom_field6',
        :'custom_field7' => :'custom_field7',
        :'customer_ip_address' => :'customer_ip_address',
        :'screen_branding_theme_code' => :'screen_branding_theme_code',
        :'storefront_host_name' => :'storefront_host_name',
        :'upsell_path_code' => :'upsell_path_code'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'comments' => :'String',
        :'custom_field1' => :'String',
        :'custom_field2' => :'String',
        :'custom_field3' => :'String',
        :'custom_field4' => :'String',
        :'custom_field5' => :'String',
        :'custom_field6' => :'String',
        :'custom_field7' => :'String',
        :'customer_ip_address' => :'String',
        :'screen_branding_theme_code' => :'String',
        :'storefront_host_name' => :'String',
        :'upsell_path_code' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'comments')
        self.comments = attributes[:'comments']
      end

      if attributes.has_key?(:'custom_field1')
        self.custom_field1 = attributes[:'custom_field1']
      end

      if attributes.has_key?(:'custom_field2')
        self.custom_field2 = attributes[:'custom_field2']
      end

      if attributes.has_key?(:'custom_field3')
        self.custom_field3 = attributes[:'custom_field3']
      end

      if attributes.has_key?(:'custom_field4')
        self.custom_field4 = attributes[:'custom_field4']
      end

      if attributes.has_key?(:'custom_field5')
        self.custom_field5 = attributes[:'custom_field5']
      end

      if attributes.has_key?(:'custom_field6')
        self.custom_field6 = attributes[:'custom_field6']
      end

      if attributes.has_key?(:'custom_field7')
        self.custom_field7 = attributes[:'custom_field7']
      end

      if attributes.has_key?(:'customer_ip_address')
        self.customer_ip_address = attributes[:'customer_ip_address']
      end

      if attributes.has_key?(:'screen_branding_theme_code')
        self.screen_branding_theme_code = attributes[:'screen_branding_theme_code']
      end

      if attributes.has_key?(:'storefront_host_name')
        self.storefront_host_name = attributes[:'storefront_host_name']
      end

      if attributes.has_key?(:'upsell_path_code')
        self.upsell_path_code = attributes[:'upsell_path_code']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@custom_field1.nil? && @custom_field1.to_s.length > 50
        invalid_properties.push('invalid value for "custom_field1", the character length must be smaller than or equal to 50.')
      end

      if !@custom_field2.nil? && @custom_field2.to_s.length > 50
        invalid_properties.push('invalid value for "custom_field2", the character length must be smaller than or equal to 50.')
      end

      if !@custom_field3.nil? && @custom_field3.to_s.length > 50
        invalid_properties.push('invalid value for "custom_field3", the character length must be smaller than or equal to 50.')
      end

      if !@custom_field4.nil? && @custom_field4.to_s.length > 50
        invalid_properties.push('invalid value for "custom_field4", the character length must be smaller than or equal to 50.')
      end

      if !@custom_field5.nil? && @custom_field5.to_s.length > 75
        invalid_properties.push('invalid value for "custom_field5", the character length must be smaller than or equal to 75.')
      end

      if !@custom_field6.nil? && @custom_field6.to_s.length > 50
        invalid_properties.push('invalid value for "custom_field6", the character length must be smaller than or equal to 50.')
      end

      if !@custom_field7.nil? && @custom_field7.to_s.length > 50
        invalid_properties.push('invalid value for "custom_field7", the character length must be smaller than or equal to 50.')
      end

      if !@screen_branding_theme_code.nil? && @screen_branding_theme_code.to_s.length > 10
        invalid_properties.push('invalid value for "screen_branding_theme_code", the character length must be smaller than or equal to 10.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@custom_field1.nil? && @custom_field1.to_s.length > 50
      return false if !@custom_field2.nil? && @custom_field2.to_s.length > 50
      return false if !@custom_field3.nil? && @custom_field3.to_s.length > 50
      return false if !@custom_field4.nil? && @custom_field4.to_s.length > 50
      return false if !@custom_field5.nil? && @custom_field5.to_s.length > 75
      return false if !@custom_field6.nil? && @custom_field6.to_s.length > 50
      return false if !@custom_field7.nil? && @custom_field7.to_s.length > 50
      return false if !@screen_branding_theme_code.nil? && @screen_branding_theme_code.to_s.length > 10
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field1 Value to be assigned
    def custom_field1=(custom_field1)
      if !custom_field1.nil? && custom_field1.to_s.length > 50
        fail ArgumentError, 'invalid value for "custom_field1", the character length must be smaller than or equal to 50.'
      end

      @custom_field1 = custom_field1
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field2 Value to be assigned
    def custom_field2=(custom_field2)
      if !custom_field2.nil? && custom_field2.to_s.length > 50
        fail ArgumentError, 'invalid value for "custom_field2", the character length must be smaller than or equal to 50.'
      end

      @custom_field2 = custom_field2
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field3 Value to be assigned
    def custom_field3=(custom_field3)
      if !custom_field3.nil? && custom_field3.to_s.length > 50
        fail ArgumentError, 'invalid value for "custom_field3", the character length must be smaller than or equal to 50.'
      end

      @custom_field3 = custom_field3
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field4 Value to be assigned
    def custom_field4=(custom_field4)
      if !custom_field4.nil? && custom_field4.to_s.length > 50
        fail ArgumentError, 'invalid value for "custom_field4", the character length must be smaller than or equal to 50.'
      end

      @custom_field4 = custom_field4
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field5 Value to be assigned
    def custom_field5=(custom_field5)
      if !custom_field5.nil? && custom_field5.to_s.length > 75
        fail ArgumentError, 'invalid value for "custom_field5", the character length must be smaller than or equal to 75.'
      end

      @custom_field5 = custom_field5
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field6 Value to be assigned
    def custom_field6=(custom_field6)
      if !custom_field6.nil? && custom_field6.to_s.length > 50
        fail ArgumentError, 'invalid value for "custom_field6", the character length must be smaller than or equal to 50.'
      end

      @custom_field6 = custom_field6
    end

    # Custom attribute writer method with validation
    # @param [Object] custom_field7 Value to be assigned
    def custom_field7=(custom_field7)
      if !custom_field7.nil? && custom_field7.to_s.length > 50
        fail ArgumentError, 'invalid value for "custom_field7", the character length must be smaller than or equal to 50.'
      end

      @custom_field7 = custom_field7
    end

    # Custom attribute writer method with validation
    # @param [Object] screen_branding_theme_code Value to be assigned
    def screen_branding_theme_code=(screen_branding_theme_code)
      if !screen_branding_theme_code.nil? && screen_branding_theme_code.to_s.length > 10
        fail ArgumentError, 'invalid value for "screen_branding_theme_code", the character length must be smaller than or equal to 10.'
      end

      @screen_branding_theme_code = screen_branding_theme_code
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          comments == o.comments &&
          custom_field1 == o.custom_field1 &&
          custom_field2 == o.custom_field2 &&
          custom_field3 == o.custom_field3 &&
          custom_field4 == o.custom_field4 &&
          custom_field5 == o.custom_field5 &&
          custom_field6 == o.custom_field6 &&
          custom_field7 == o.custom_field7 &&
          customer_ip_address == o.customer_ip_address &&
          screen_branding_theme_code == o.screen_branding_theme_code &&
          storefront_host_name == o.storefront_host_name &&
          upsell_path_code == o.upsell_path_code
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [comments, custom_field1, custom_field2, custom_field3, custom_field4, custom_field5, custom_field6, custom_field7, customer_ip_address, screen_branding_theme_code, storefront_host_name, upsell_path_code].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
