=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class OrderCoupon
    # QuickBooks accounting code for this coupon
    attr_accessor :accounting_code

    # Whether or not the coupon was automatically applied to the order
    attr_accessor :automatically_applied

    # Coupon code configured by the merchant.  Will differ if the customer used a one time coupon code generated off this base coupon
    attr_accessor :base_coupon_code

    # Coupon code entered by the customer
    attr_accessor :coupon_code

    # True if this coupon is hidde from the customer
    attr_accessor :hdie_from_customer

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'accounting_code' => :'accounting_code',
        :'automatically_applied' => :'automatically_applied',
        :'base_coupon_code' => :'base_coupon_code',
        :'coupon_code' => :'coupon_code',
        :'hdie_from_customer' => :'hdie_from_customer'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'accounting_code' => :'String',
        :'automatically_applied' => :'BOOLEAN',
        :'base_coupon_code' => :'String',
        :'coupon_code' => :'String',
        :'hdie_from_customer' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'accounting_code')
        self.accounting_code = attributes[:'accounting_code']
      end

      if attributes.has_key?(:'automatically_applied')
        self.automatically_applied = attributes[:'automatically_applied']
      end

      if attributes.has_key?(:'base_coupon_code')
        self.base_coupon_code = attributes[:'base_coupon_code']
      end

      if attributes.has_key?(:'coupon_code')
        self.coupon_code = attributes[:'coupon_code']
      end

      if attributes.has_key?(:'hdie_from_customer')
        self.hdie_from_customer = attributes[:'hdie_from_customer']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@base_coupon_code.nil? && @base_coupon_code.to_s.length > 20
        invalid_properties.push('invalid value for "base_coupon_code", the character length must be smaller than or equal to 20.')
      end

      if !@coupon_code.nil? && @coupon_code.to_s.length > 20
        invalid_properties.push('invalid value for "coupon_code", the character length must be smaller than or equal to 20.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@base_coupon_code.nil? && @base_coupon_code.to_s.length > 20
      return false if !@coupon_code.nil? && @coupon_code.to_s.length > 20
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] base_coupon_code Value to be assigned
    def base_coupon_code=(base_coupon_code)
      if !base_coupon_code.nil? && base_coupon_code.to_s.length > 20
        fail ArgumentError, 'invalid value for "base_coupon_code", the character length must be smaller than or equal to 20.'
      end

      @base_coupon_code = base_coupon_code
    end

    # Custom attribute writer method with validation
    # @param [Object] coupon_code Value to be assigned
    def coupon_code=(coupon_code)
      if !coupon_code.nil? && coupon_code.to_s.length > 20
        fail ArgumentError, 'invalid value for "coupon_code", the character length must be smaller than or equal to 20.'
      end

      @coupon_code = coupon_code
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          accounting_code == o.accounting_code &&
          automatically_applied == o.automatically_applied &&
          base_coupon_code == o.base_coupon_code &&
          coupon_code == o.coupon_code &&
          hdie_from_customer == o.hdie_from_customer
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [accounting_code, automatically_applied, base_coupon_code, coupon_code, hdie_from_customer].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
