=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class OrderEdi
    # Billing address identification code from the EDI order.  Typically DUNS or DUNS+4
    attr_accessor :bill_to_edi_code

    # Department number associated with this EDI order
    attr_accessor :edi_department

    # Internal vendor number associated with this EDI order
    attr_accessor :edi_internal_vendor_number

    # Shipping address identification code from the EDI order.  Typically DUNS or DUNS+4
    attr_accessor :ship_to_edi_code

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'bill_to_edi_code' => :'bill_to_edi_code',
        :'edi_department' => :'edi_department',
        :'edi_internal_vendor_number' => :'edi_internal_vendor_number',
        :'ship_to_edi_code' => :'ship_to_edi_code'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'bill_to_edi_code' => :'String',
        :'edi_department' => :'String',
        :'edi_internal_vendor_number' => :'String',
        :'ship_to_edi_code' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'bill_to_edi_code')
        self.bill_to_edi_code = attributes[:'bill_to_edi_code']
      end

      if attributes.has_key?(:'edi_department')
        self.edi_department = attributes[:'edi_department']
      end

      if attributes.has_key?(:'edi_internal_vendor_number')
        self.edi_internal_vendor_number = attributes[:'edi_internal_vendor_number']
      end

      if attributes.has_key?(:'ship_to_edi_code')
        self.ship_to_edi_code = attributes[:'ship_to_edi_code']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@edi_internal_vendor_number.nil? && @edi_internal_vendor_number.to_s.length > 50
        invalid_properties.push('invalid value for "edi_internal_vendor_number", the character length must be smaller than or equal to 50.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@edi_internal_vendor_number.nil? && @edi_internal_vendor_number.to_s.length > 50
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] edi_internal_vendor_number Value to be assigned
    def edi_internal_vendor_number=(edi_internal_vendor_number)
      if !edi_internal_vendor_number.nil? && edi_internal_vendor_number.to_s.length > 50
        fail ArgumentError, 'invalid value for "edi_internal_vendor_number", the character length must be smaller than or equal to 50.'
      end

      @edi_internal_vendor_number = edi_internal_vendor_number
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          bill_to_edi_code == o.bill_to_edi_code &&
          edi_department == o.edi_department &&
          edi_internal_vendor_number == o.edi_internal_vendor_number &&
          ship_to_edi_code == o.ship_to_edi_code
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [bill_to_edi_code, edi_department, edi_internal_vendor_number, ship_to_edi_code].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
