=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class OrderTaxes
    # Arbitrary Tax, this is meaningless for updating an order.  For inserting a new order, this will override any internal tax calculations and should only be used for orders completed outside the system.
    attr_accessor :arbitrary_tax

    # Arbitrary tax rate, this is meaningless for updating an order.  For inserting a new order, this will override any internal tax calculations and should only be used for orders completed outside the system.
    attr_accessor :arbitrary_tax_rate

    # Arbitrary taxable subtotal, this is meaningless for updating an order.  For inserting a new order, this will override any internal tax calculations and should only be used for orders completed outside the system.
    attr_accessor :arbitrary_taxable_subtotal

    # QuickBooks tax city code
    attr_accessor :tax_city_accounting_code

    # QuickBooks tax country code
    attr_accessor :tax_country_accounting_code

    # County used for tax calculation purposes (only in the United States)
    attr_accessor :tax_county

    # QuickBooks tax county code
    attr_accessor :tax_county_accounting_code

    # True if gift charge is taxed
    attr_accessor :tax_gift_charge

    # QuickBooks tax postal code code
    attr_accessor :tax_postal_code_accounting_code

    # Tax rate, this is meaningless for updating an order.  For inserting a new order, if you need to override internal tax calculations, use the arbitrary fields.
    attr_accessor :tax_rate

    # Tax rate at the city level
    attr_accessor :tax_rate_city

    # Tax rate at the country level
    attr_accessor :tax_rate_country

    # Tax rate at the county level
    attr_accessor :tax_rate_county

    # Tax rate at the postal code level
    attr_accessor :tax_rate_postal_code

    # Tax rate at the state level
    attr_accessor :tax_rate_state

    # True if shipping is taxed
    attr_accessor :tax_shipping

    # QuickBooks tax state code
    attr_accessor :tax_state_accounting_code

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'arbitrary_tax' => :'arbitrary_tax',
        :'arbitrary_tax_rate' => :'arbitrary_tax_rate',
        :'arbitrary_taxable_subtotal' => :'arbitrary_taxable_subtotal',
        :'tax_city_accounting_code' => :'tax_city_accounting_code',
        :'tax_country_accounting_code' => :'tax_country_accounting_code',
        :'tax_county' => :'tax_county',
        :'tax_county_accounting_code' => :'tax_county_accounting_code',
        :'tax_gift_charge' => :'tax_gift_charge',
        :'tax_postal_code_accounting_code' => :'tax_postal_code_accounting_code',
        :'tax_rate' => :'tax_rate',
        :'tax_rate_city' => :'tax_rate_city',
        :'tax_rate_country' => :'tax_rate_country',
        :'tax_rate_county' => :'tax_rate_county',
        :'tax_rate_postal_code' => :'tax_rate_postal_code',
        :'tax_rate_state' => :'tax_rate_state',
        :'tax_shipping' => :'tax_shipping',
        :'tax_state_accounting_code' => :'tax_state_accounting_code'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'arbitrary_tax' => :'Float',
        :'arbitrary_tax_rate' => :'Float',
        :'arbitrary_taxable_subtotal' => :'Float',
        :'tax_city_accounting_code' => :'String',
        :'tax_country_accounting_code' => :'String',
        :'tax_county' => :'String',
        :'tax_county_accounting_code' => :'String',
        :'tax_gift_charge' => :'BOOLEAN',
        :'tax_postal_code_accounting_code' => :'String',
        :'tax_rate' => :'Float',
        :'tax_rate_city' => :'Float',
        :'tax_rate_country' => :'Float',
        :'tax_rate_county' => :'Float',
        :'tax_rate_postal_code' => :'Float',
        :'tax_rate_state' => :'Float',
        :'tax_shipping' => :'BOOLEAN',
        :'tax_state_accounting_code' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'arbitrary_tax')
        self.arbitrary_tax = attributes[:'arbitrary_tax']
      end

      if attributes.has_key?(:'arbitrary_tax_rate')
        self.arbitrary_tax_rate = attributes[:'arbitrary_tax_rate']
      end

      if attributes.has_key?(:'arbitrary_taxable_subtotal')
        self.arbitrary_taxable_subtotal = attributes[:'arbitrary_taxable_subtotal']
      end

      if attributes.has_key?(:'tax_city_accounting_code')
        self.tax_city_accounting_code = attributes[:'tax_city_accounting_code']
      end

      if attributes.has_key?(:'tax_country_accounting_code')
        self.tax_country_accounting_code = attributes[:'tax_country_accounting_code']
      end

      if attributes.has_key?(:'tax_county')
        self.tax_county = attributes[:'tax_county']
      end

      if attributes.has_key?(:'tax_county_accounting_code')
        self.tax_county_accounting_code = attributes[:'tax_county_accounting_code']
      end

      if attributes.has_key?(:'tax_gift_charge')
        self.tax_gift_charge = attributes[:'tax_gift_charge']
      end

      if attributes.has_key?(:'tax_postal_code_accounting_code')
        self.tax_postal_code_accounting_code = attributes[:'tax_postal_code_accounting_code']
      end

      if attributes.has_key?(:'tax_rate')
        self.tax_rate = attributes[:'tax_rate']
      end

      if attributes.has_key?(:'tax_rate_city')
        self.tax_rate_city = attributes[:'tax_rate_city']
      end

      if attributes.has_key?(:'tax_rate_country')
        self.tax_rate_country = attributes[:'tax_rate_country']
      end

      if attributes.has_key?(:'tax_rate_county')
        self.tax_rate_county = attributes[:'tax_rate_county']
      end

      if attributes.has_key?(:'tax_rate_postal_code')
        self.tax_rate_postal_code = attributes[:'tax_rate_postal_code']
      end

      if attributes.has_key?(:'tax_rate_state')
        self.tax_rate_state = attributes[:'tax_rate_state']
      end

      if attributes.has_key?(:'tax_shipping')
        self.tax_shipping = attributes[:'tax_shipping']
      end

      if attributes.has_key?(:'tax_state_accounting_code')
        self.tax_state_accounting_code = attributes[:'tax_state_accounting_code']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@tax_county.nil? && @tax_county.to_s.length > 32
        invalid_properties.push('invalid value for "tax_county", the character length must be smaller than or equal to 32.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@tax_county.nil? && @tax_county.to_s.length > 32
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] tax_county Value to be assigned
    def tax_county=(tax_county)
      if !tax_county.nil? && tax_county.to_s.length > 32
        fail ArgumentError, 'invalid value for "tax_county", the character length must be smaller than or equal to 32.'
      end

      @tax_county = tax_county
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          arbitrary_tax == o.arbitrary_tax &&
          arbitrary_tax_rate == o.arbitrary_tax_rate &&
          arbitrary_taxable_subtotal == o.arbitrary_taxable_subtotal &&
          tax_city_accounting_code == o.tax_city_accounting_code &&
          tax_country_accounting_code == o.tax_country_accounting_code &&
          tax_county == o.tax_county &&
          tax_county_accounting_code == o.tax_county_accounting_code &&
          tax_gift_charge == o.tax_gift_charge &&
          tax_postal_code_accounting_code == o.tax_postal_code_accounting_code &&
          tax_rate == o.tax_rate &&
          tax_rate_city == o.tax_rate_city &&
          tax_rate_country == o.tax_rate_country &&
          tax_rate_county == o.tax_rate_county &&
          tax_rate_postal_code == o.tax_rate_postal_code &&
          tax_rate_state == o.tax_rate_state &&
          tax_shipping == o.tax_shipping &&
          tax_state_accounting_code == o.tax_state_accounting_code
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [arbitrary_tax, arbitrary_tax_rate, arbitrary_taxable_subtotal, tax_city_accounting_code, tax_country_accounting_code, tax_county, tax_county_accounting_code, tax_gift_charge, tax_postal_code_accounting_code, tax_rate, tax_rate_city, tax_rate_country, tax_rate_county, tax_rate_postal_code, tax_rate_state, tax_shipping, tax_state_accounting_code].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
