=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class OrderTrackingNumberDetail
    attr_accessor :city

    # ISO 8601 timestamp that the event occurred
    attr_accessor :event_dts

    attr_accessor :event_local_date

    attr_accessor :event_local_time

    # Timezone the event occurred in.  Use this in conjunction with event_dts to format a local date/time.
    attr_accessor :event_timezone_id

    attr_accessor :state

    attr_accessor :subtag

    attr_accessor :subtag_message

    attr_accessor :tag

    attr_accessor :tag_description

    attr_accessor :tag_icon

    attr_accessor :zip

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'city' => :'city',
        :'event_dts' => :'event_dts',
        :'event_local_date' => :'event_local_date',
        :'event_local_time' => :'event_local_time',
        :'event_timezone_id' => :'event_timezone_id',
        :'state' => :'state',
        :'subtag' => :'subtag',
        :'subtag_message' => :'subtag_message',
        :'tag' => :'tag',
        :'tag_description' => :'tag_description',
        :'tag_icon' => :'tag_icon',
        :'zip' => :'zip'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'city' => :'String',
        :'event_dts' => :'String',
        :'event_local_date' => :'String',
        :'event_local_time' => :'String',
        :'event_timezone_id' => :'String',
        :'state' => :'String',
        :'subtag' => :'String',
        :'subtag_message' => :'String',
        :'tag' => :'String',
        :'tag_description' => :'String',
        :'tag_icon' => :'String',
        :'zip' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'city')
        self.city = attributes[:'city']
      end

      if attributes.has_key?(:'event_dts')
        self.event_dts = attributes[:'event_dts']
      end

      if attributes.has_key?(:'event_local_date')
        self.event_local_date = attributes[:'event_local_date']
      end

      if attributes.has_key?(:'event_local_time')
        self.event_local_time = attributes[:'event_local_time']
      end

      if attributes.has_key?(:'event_timezone_id')
        self.event_timezone_id = attributes[:'event_timezone_id']
      end

      if attributes.has_key?(:'state')
        self.state = attributes[:'state']
      end

      if attributes.has_key?(:'subtag')
        self.subtag = attributes[:'subtag']
      end

      if attributes.has_key?(:'subtag_message')
        self.subtag_message = attributes[:'subtag_message']
      end

      if attributes.has_key?(:'tag')
        self.tag = attributes[:'tag']
      end

      if attributes.has_key?(:'tag_description')
        self.tag_description = attributes[:'tag_description']
      end

      if attributes.has_key?(:'tag_icon')
        self.tag_icon = attributes[:'tag_icon']
      end

      if attributes.has_key?(:'zip')
        self.zip = attributes[:'zip']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          city == o.city &&
          event_dts == o.event_dts &&
          event_local_date == o.event_local_date &&
          event_local_time == o.event_local_time &&
          event_timezone_id == o.event_timezone_id &&
          state == o.state &&
          subtag == o.subtag &&
          subtag_message == o.subtag_message &&
          tag == o.tag &&
          tag_description == o.tag_description &&
          tag_icon == o.tag_icon &&
          zip == o.zip
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [city, event_dts, event_local_date, event_local_time, event_timezone_id, state, subtag, subtag_message, tag, tag_description, tag_icon, zip].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
