=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class ScreenRecordingSegment
    attr_accessor :create_dts

    attr_accessor :description

    attr_accessor :filter

    attr_accessor :histogram_data

    attr_accessor :histogram_interval

    attr_accessor :histogram_start_dts

    attr_accessor :name

    attr_accessor :screen_recording_segment_oid

    attr_accessor :session_count

    attr_accessor :session_count_last_update_dts

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'create_dts' => :'create_dts',
        :'description' => :'description',
        :'filter' => :'filter',
        :'histogram_data' => :'histogram_data',
        :'histogram_interval' => :'histogram_interval',
        :'histogram_start_dts' => :'histogram_start_dts',
        :'name' => :'name',
        :'screen_recording_segment_oid' => :'screen_recording_segment_oid',
        :'session_count' => :'session_count',
        :'session_count_last_update_dts' => :'session_count_last_update_dts'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'create_dts' => :'String',
        :'description' => :'String',
        :'filter' => :'ScreenRecordingFilter',
        :'histogram_data' => :'Array<Integer>',
        :'histogram_interval' => :'String',
        :'histogram_start_dts' => :'String',
        :'name' => :'String',
        :'screen_recording_segment_oid' => :'Integer',
        :'session_count' => :'Integer',
        :'session_count_last_update_dts' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'create_dts')
        self.create_dts = attributes[:'create_dts']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'filter')
        self.filter = attributes[:'filter']
      end

      if attributes.has_key?(:'histogram_data')
        if (value = attributes[:'histogram_data']).is_a?(Array)
          self.histogram_data = value
        end
      end

      if attributes.has_key?(:'histogram_interval')
        self.histogram_interval = attributes[:'histogram_interval']
      end

      if attributes.has_key?(:'histogram_start_dts')
        self.histogram_start_dts = attributes[:'histogram_start_dts']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'screen_recording_segment_oid')
        self.screen_recording_segment_oid = attributes[:'screen_recording_segment_oid']
      end

      if attributes.has_key?(:'session_count')
        self.session_count = attributes[:'session_count']
      end

      if attributes.has_key?(:'session_count_last_update_dts')
        self.session_count_last_update_dts = attributes[:'session_count_last_update_dts']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          create_dts == o.create_dts &&
          description == o.description &&
          filter == o.filter &&
          histogram_data == o.histogram_data &&
          histogram_interval == o.histogram_interval &&
          histogram_start_dts == o.histogram_start_dts &&
          name == o.name &&
          screen_recording_segment_oid == o.screen_recording_segment_oid &&
          session_count == o.session_count &&
          session_count_last_update_dts == o.session_count_last_update_dts
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [create_dts, description, filter, histogram_data, histogram_interval, histogram_start_dts, name, screen_recording_segment_oid, session_count, session_count_last_update_dts].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
