=begin
#UltraCart Rest API V2

#UltraCart REST API Version 2

OpenAPI spec version: 2.0.0
Contact: support@ultracart.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.15-SNAPSHOT

=end

require 'date'

module UltracartClient
  class TransactionEmail
    # Actual template contents
    attr_accessor :content

    # The uuid of the sending domain
    attr_accessor :esp_domain_uuid

    # Friendly from that will appear in customer email clients.
    attr_accessor :esp_friendly_name

    # The username of the sending email.  This is not the full email.  Only the username which is everything before the @ sign.
    attr_accessor :esp_user

    # An internal identifier used to aid in retrieving templates from the filesystem.
    attr_accessor :file_exists

    # File name
    attr_accessor :file_name

    # Group
    attr_accessor :group

    # Handlebar Variables available for email template
    attr_accessor :handlebar_variables

    # Invalid will be true if the template cannot compile
    attr_accessor :invalid

    # Last modified timestamp
    attr_accessor :last_modified

    # If this item was ever added to the Code Library, this is the oid for that library item, or 0 if never added before.  This value is used to determine if a library item should be inserted or updated.
    attr_accessor :library_item_oid

    # Options that help govern how and when this template is used
    attr_accessor :options

    # directory path where template is stored in file system
    attr_accessor :path

    # Size of file in friendly description
    attr_accessor :size

    # Internal identifier used to store and retrieve template from filesystem
    attr_accessor :store_front_fs_directory_oid

    # Internal identifier used to store and retrieve template from filesystem
    attr_accessor :store_front_fs_file_oid

    # Subject
    attr_accessor :subject

    # Any syntax errors contained within the tempalate
    attr_accessor :syntax_errors

    # Internal value used to locate the template in the filesystem
    attr_accessor :template_path_relative_path

    # Theme relative path in the filesystem.
    attr_accessor :theme_relative_path

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'content' => :'content',
        :'esp_domain_uuid' => :'esp_domain_uuid',
        :'esp_friendly_name' => :'esp_friendly_name',
        :'esp_user' => :'esp_user',
        :'file_exists' => :'file_exists',
        :'file_name' => :'file_name',
        :'group' => :'group',
        :'handlebar_variables' => :'handlebar_variables',
        :'invalid' => :'invalid',
        :'last_modified' => :'last_modified',
        :'library_item_oid' => :'library_item_oid',
        :'options' => :'options',
        :'path' => :'path',
        :'size' => :'size',
        :'store_front_fs_directory_oid' => :'store_front_fs_directory_oid',
        :'store_front_fs_file_oid' => :'store_front_fs_file_oid',
        :'subject' => :'subject',
        :'syntax_errors' => :'syntax_errors',
        :'template_path_relative_path' => :'template_path_relative_path',
        :'theme_relative_path' => :'theme_relative_path'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'content' => :'String',
        :'esp_domain_uuid' => :'String',
        :'esp_friendly_name' => :'String',
        :'esp_user' => :'String',
        :'file_exists' => :'BOOLEAN',
        :'file_name' => :'String',
        :'group' => :'String',
        :'handlebar_variables' => :'Array<String>',
        :'invalid' => :'BOOLEAN',
        :'last_modified' => :'String',
        :'library_item_oid' => :'Integer',
        :'options' => :'Array<TransactionEmailOption>',
        :'path' => :'String',
        :'size' => :'String',
        :'store_front_fs_directory_oid' => :'Integer',
        :'store_front_fs_file_oid' => :'Integer',
        :'subject' => :'String',
        :'syntax_errors' => :'String',
        :'template_path_relative_path' => :'String',
        :'theme_relative_path' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'content')
        self.content = attributes[:'content']
      end

      if attributes.has_key?(:'esp_domain_uuid')
        self.esp_domain_uuid = attributes[:'esp_domain_uuid']
      end

      if attributes.has_key?(:'esp_friendly_name')
        self.esp_friendly_name = attributes[:'esp_friendly_name']
      end

      if attributes.has_key?(:'esp_user')
        self.esp_user = attributes[:'esp_user']
      end

      if attributes.has_key?(:'file_exists')
        self.file_exists = attributes[:'file_exists']
      end

      if attributes.has_key?(:'file_name')
        self.file_name = attributes[:'file_name']
      end

      if attributes.has_key?(:'group')
        self.group = attributes[:'group']
      end

      if attributes.has_key?(:'handlebar_variables')
        if (value = attributes[:'handlebar_variables']).is_a?(Array)
          self.handlebar_variables = value
        end
      end

      if attributes.has_key?(:'invalid')
        self.invalid = attributes[:'invalid']
      end

      if attributes.has_key?(:'last_modified')
        self.last_modified = attributes[:'last_modified']
      end

      if attributes.has_key?(:'library_item_oid')
        self.library_item_oid = attributes[:'library_item_oid']
      end

      if attributes.has_key?(:'options')
        if (value = attributes[:'options']).is_a?(Array)
          self.options = value
        end
      end

      if attributes.has_key?(:'path')
        self.path = attributes[:'path']
      end

      if attributes.has_key?(:'size')
        self.size = attributes[:'size']
      end

      if attributes.has_key?(:'store_front_fs_directory_oid')
        self.store_front_fs_directory_oid = attributes[:'store_front_fs_directory_oid']
      end

      if attributes.has_key?(:'store_front_fs_file_oid')
        self.store_front_fs_file_oid = attributes[:'store_front_fs_file_oid']
      end

      if attributes.has_key?(:'subject')
        self.subject = attributes[:'subject']
      end

      if attributes.has_key?(:'syntax_errors')
        self.syntax_errors = attributes[:'syntax_errors']
      end

      if attributes.has_key?(:'template_path_relative_path')
        self.template_path_relative_path = attributes[:'template_path_relative_path']
      end

      if attributes.has_key?(:'theme_relative_path')
        self.theme_relative_path = attributes[:'theme_relative_path']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          content == o.content &&
          esp_domain_uuid == o.esp_domain_uuid &&
          esp_friendly_name == o.esp_friendly_name &&
          esp_user == o.esp_user &&
          file_exists == o.file_exists &&
          file_name == o.file_name &&
          group == o.group &&
          handlebar_variables == o.handlebar_variables &&
          invalid == o.invalid &&
          last_modified == o.last_modified &&
          library_item_oid == o.library_item_oid &&
          options == o.options &&
          path == o.path &&
          size == o.size &&
          store_front_fs_directory_oid == o.store_front_fs_directory_oid &&
          store_front_fs_file_oid == o.store_front_fs_file_oid &&
          subject == o.subject &&
          syntax_errors == o.syntax_errors &&
          template_path_relative_path == o.template_path_relative_path &&
          theme_relative_path == o.theme_relative_path
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [content, esp_domain_uuid, esp_friendly_name, esp_user, file_exists, file_name, group, handlebar_variables, invalid, last_modified, library_item_oid, options, path, size, store_front_fs_directory_oid, store_front_fs_file_oid, subject, syntax_errors, template_path_relative_path, theme_relative_path].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = UltracartClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
